/*	Copyright  (c)	Günter Woigk 2005 - 2007
  					mailto:kio@little-bat.de

 	This program is distributed in the hope that it will be useful,
 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

 	Permission to use, copy, modify, distribute, and sell this software and
 	its documentation for any purpose is hereby granted without fee, provided
 	that the above copyright notice appear in all copies and that both that
 	copyright notice and this permission notice appear in supporting
 	documentation, and that the name of the copyright holder not be used
 	in advertising or publicity pertaining to distribution of the software
 	without specific, written prior permission.  The copyright holder makes no
 	representations about the suitability of this software for any purpose.
 	It is provided "as is" without express or implied warranty.

 	THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 	INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 	EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 	DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 	TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 	PERFORMANCE OF THIS SOFTWARE.
*/


#import "kio/kio.h"


typedef enum { urlClosed, urlGetList, urlSilentGetList, urlGotList, urlGetFile, urlGotFile, urlNoUpdate, urlError } UrlState;


@interface CheckUpdateController : NSObject
{
    IBOutlet id check_update_menu_item;

    IBOutlet id progress_window;
    IBOutlet id message_view;
    IBOutlet id progress_bar;

	IBOutlet id check_preview_switch;
    IBOutlet id close_button;
    IBOutlet id download_button;

    IBOutlet id automatic_update_switch;
    IBOutlet id automatic_update_group;
	
	bool			checkPreview;			// from prefs. toggled by checkbox
	NSURL*			baseUrl;				// http://k1.dyndns.org/Develop/projects/zxsp-osx/distributions
	
	UrlState		urlState;				// state tracker
	
	cstr			fileNameUpdate;			// extracted from directory listing
	cstr			fileNamePreview;		// if any
	
	NSString*		saveFilePath;			// from "save file" panel
	
	NSURLRequest*	urlRequest;
	NSURLConnection*urlConnection;	
	NSMutableData*	urlData;
}

- (IBAction)doDownload:(id)sender;
- (IBAction)setCheckPreview:(id)sender;

- (IBAction)doClose:(id)sender;
- (IBAction)doOpen:(id)sender;

- (IBAction)toggleAutomaticUpdate:(id)sender;
- (IBAction)setAutomaticUpdateIntervall:(id)sender;

- (void)automaticCheckUpdate;

@end







