/*	Copyright  (c)	Günter Woigk 2007 - 2008
  					mailto:kio@little-bat.de

 	This program is distributed in the hope that it will be useful,
 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

 	Permission to use, copy, modify, distribute, and sell this software and
 	its documentation for any purpose is hereby granted without fee, provided
 	that the above copyright notice appear in all copies and that both that
 	copyright notice and this permission notice appear in supporting
 	documentation, and that the name of the copyright holder not be used
 	in advertising or publicity pertaining to distribution of the software
 	without specific, written prior permission.  The copyright holder makes no
 	representations about the suitability of this software for any purpose.
 	It is provided "as is" without express or implied warranty.

 	THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 	INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 	EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 	DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 	TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 	PERFORMANCE OF THIS SOFTWARE.
*/

#define SAFE	3
#define LOG 	1

#import "cstrings/cstrings.h"
#import "MachinePanel.h"
#import "NXImage.h"
#import "Machine.h"


static NSImage* images[zxmodels];



@implementation MachinePanel


-(id)initWithContentRect:(NSRect)contentRect 
			   styleMask:(uint)styleMask 
			     backing:(NSBackingStoreType)backingType 
				   defer:(BOOL)flag
{
	XLogIn("MachinePanel:initWithContentRect");
	
	return machine_panel = self =
		[super initWithContentRect:contentRect styleMask:styleMask 
						backing:backingType defer:flag];
}


//- (void)awakeFromNib { XLogIn("MachinePanel:awakeFromNib"); }


/* ----------------------------------------------------------
	Update Panel: 
	Called by NXPanel:updateAllPanels() from main event loop:
	- for regular panel update
	- called only if panel is visible
	- front machine m is locked for reading (RLOCK/RUNLOCK)
*/
-(void)updatePanel:(Machine*)m
{
	static uint old_model = zx48i3;		// image is set to zxsp 48k in NIB file
	uint model = m->GetModel();

	if( old_model != model )
	{
		old_model = model;

		if( !images[zx48i3] ) { images[zx48i2] = images[zx48i3] = [imageView image]; }
		if( !images[model] ) images[model] = [[NXImage alloc] initWithContentsOfResourceFile:m->GetInfo()->image_filename];

		[imageView setImage:images[model]];
	}
}

@end











