/*	Copyright  (c)	Günter Woigk 2006 - 2008
  					mailto:kio@little-bat.de

 	This program is distributed in the hope that it will be useful,
 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

 	Permission to use, copy, modify, distribute, and sell this software and
 	its documentation for any purpose is hereby granted without fee, provided
 	that the above copyright notice appear in all copies and that both that
 	copyright notice and this permission notice appear in supporting
 	documentation, and that the name of the copyright holder not be used
 	in advertising or publicity pertaining to distribution of the software
 	without specific, written prior permission.  The copyright holder makes no
 	representations about the suitability of this software for any purpose.
 	It is provided "as is" without express or implied warranty.

 	THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 	INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 	EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 	DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 	TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 	PERFORMANCE OF THIS SOFTWARE.
*/
 

#ifndef globals_h
#define globals_h

#import "zxsp_types.h"


extern	bool	 	fullscreen_mode;		// set by @class Screen
extern	int			frames_hit_count;		// draw_screen performance counter
extern	uint 		modifier_keys;			// set by @class KbdPanel

extern	Frequency	samples_per_second;		// DSP-Konstante & Zeitbasis des Systems: samples/second
extern	Time		system_time;			// Realzeit [seconds]

namespace DSP{
extern	StereoSample audio_out_buffer[];
extern	Sample		 audio_in_buffer [];
}

extern	cstr		appl_name;				// set by main()
extern	cstr		appl_path;				// set by main()
extern	cstr		rsrc_path;				// set by main()
extern	cstr		appl_version_str;		// set in main.mm: "0.6.4"
extern	cstr		appl_pre_version_str;	// set in main.mm: "pre123" or "" if public release
#define				appl_is_preview			(appl_pre_version_str[0]!=0)

extern	ZxInfo		zx_info[];

extern	JoystickList	joystick_list;
extern	MachineList		machine_list;
extern	DisplayList		display_list;


#ifdef __OBJC__
	extern	KeyboardJoystickPanel*			keyboard_joystick_panel;
	extern	SinclairZxInterface2Panel*		sinclair_zx_interface2_panel;
	extern	SinclairZxInterface1Panel*		sinclair_zx_interface1_panel;
	extern	KempstonJoystickInterfacePanel*	kempston_jsif_panel;
	extern	KempstonMouseInterfacePanel*	kempston_mouse_if_panel;
	extern	ZxPlus2JoystickPortsPanel*		zxplus2_js_ports_panel;
	extern	ZonxBoxPanel*					zonx_box_panel;

	extern	NSThread*		main_thread;
#	define	MAIN_THREAD		([NSThread currentThread] == main_thread)

	extern	ZXPrinterPanel*	zxprinter_panel;
	extern	MenuController*	menu_controller;
	extern	TapeRecorder*	tape_recorder;
	extern	ICTesterPanel*	ictester_panel;
	extern	AyPanel*		ay_panel;
	extern	CpuPanel*		cpu_panel;
	extern	KbdPanel*		kbd_panel;
	extern	MemoryPanel*	memory_panel;
	extern	FdcPanel*		fdc_panel;
	extern	Preferences*	preferences;
	extern	UlaPanel*		ula_panel;
	extern	MachinePanel*	machine_panel;
	
#else
	extern	bool			IsMainThread();
#	define	MAIN_THREAD		IsMainThread()
#endif







#endif
