/*	Copyright  (c)	Günter Woigk 2007 - 2007
  					mailto:kio@little-bat.de

 	This program is distributed in the hope that it will be useful,
 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

 	Permission to use, copy, modify, distribute, and sell this software and
 	its documentation for any purpose is hereby granted without fee, provided
 	that the above copyright notice appear in all copies and that both that
 	copyright notice and this permission notice appear in supporting
 	documentation, and that the name of the copyright holder not be used
 	in advertising or publicity pertaining to distribution of the software
 	without specific, written prior permission.  The copyright holder makes no
 	representations about the suitability of this software for any purpose.
 	It is provided "as is" without express or implied warranty.

 	THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 	INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 	EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 	DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 	TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 	PERFORMANCE OF THIS SOFTWARE.
*/

#define SAFE	3
#define LOG 	1

#import "globals.h"
#import "NXImageView.h"
#import "NXImage.h"


#define	EMPTY_IMAGE		"disabled_image.jpg"


static NSImage* EmptyImage()
{
	static NSImage*	image  = nil;
	if( !image ) { image = [[NXImage alloc] initWithContentsOfResourceFile:EMPTY_IMAGE]; }
	return image;
}



@implementation NXImageView

/* designated NSObject initializer:
*/
-(id)init	
{
	nx_image = nil;
	return [super init];
}


//-(void)dealloc
//{
//	[super dealloc];
//}


- (BOOL)isEnabled
{
	return nx_image == nil;
}


-(void)setEnabled:(BOOL)f
{
	if(f)	// enable:
	{
		if( nx_image ) 
		{
			[super setImage:nx_image];
			nx_image = nil;
		}
	}
	else	// disable:
	{
		if( nx_image==nil )
		{
			nx_image = [super image];
			[super setImage:EmptyImage()];
		}
	}
}


@end







