/*	Copyright  (c)	Günter Woigk 2007 - 2008
  					mailto:kio@little-bat.de

 	This program is distributed in the hope that it will be useful,
 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

 	Permission to use, copy, modify, distribute, and sell this software and
 	its documentation for any purpose is hereby granted without fee, provided
 	that the above copyright notice appear in all copies and that both that
 	copyright notice and this permission notice appear in supporting
 	documentation, and that the name of the copyright holder not be used
 	in advertising or publicity pertaining to distribution of the software
 	without specific, written prior permission.  The copyright holder makes no
 	representations about the suitability of this software for any purpose.
 	It is provided "as is" without express or implied warranty.

 	THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 	INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 	EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 	DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 	TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 	PERFORMANCE OF THIS SOFTWARE.

	Create GIF files from ZX Spectrum screens
*/


#ifndef ZxPixelmap_h
#define	ZxPixelmap_h

#include "gif/Pixelmap.h"
#include "gif/Colormap.h"


extern	cColormap	zx_cmap;				// 16 standard Specci colors
		int const	zx_transp_color = 8;	// 'bright black' used for transparency
extern	uchar		a2c[256];
inline	uchar		a2b( uchar i )  { return a2c[i]; }
inline	uchar		a2f( uchar i )  { return (a2c+128)[char(i)]; }
inline	uchar		a2b( ushort i ) { return a2c[i>>8]; }
inline	uchar		a2f( ushort i ) { return (a2c+128)[short(i)>>8]; }



class ZxPixelmap : public Pixelmap
{
public:	
	ZxPixelmap	()				: Pixelmap(0,0,256,192) {}
	ZxPixelmap	( ushort attr_pixel[], cBox& frame );
	ZxPixelmap	( ushort attr_pixel[] );
	ZxPixelmap	( ushort attr_pixel[], uchar border[], int ula_top_lines, int ula_row_bytes, int h_border=32, int v_border=24 );

	void		SetToScreen		( ushort attr_pixel[] );
	void		SetToScreenDiff	( ushort new_attr_pixel[], ushort old_attr_pixel[] );
};



#endif











