/*	Copyright  (c)	Günter Woigk 2006 - 2007
  					mailto:kio@little-bat.de

 	This program is distributed in the hope that it will be useful,
 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

 	Permission to use, copy, modify, distribute, and sell this software and
 	its documentation for any purpose is hereby granted without fee, provided
 	that the above copyright notice appear in all copies and that both that
 	copyright notice and this permission notice appear in supporting
 	documentation, and that the name of the copyright holder not be used
 	in advertising or publicity pertaining to distribution of the software
 	without specific, written prior permission.  The copyright holder makes no
 	representations about the suitability of this software for any purpose.
 	It is provided "as is" without express or implied warranty.

 	THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 	INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 	EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 	DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 	TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 	PERFORMANCE OF THIS SOFTWARE.
*/


#ifndef KempstonMouseInterface_h
#define KempstonMouseInterface_h

#import "ZxItem.h"
#import "Machine.h"
#import "KempstonMouseInterfacePanel.h"
#import "Mouse.h"


class KempstonMouseInterface : public ZxItem
{
// all mouse interfaces for all open machine instances share all one mouse
// the x and y values here are remembered values used while a machine is in the background
// so that the mouse moves only for the frontmost machine
// the buttons need no remembered state, because the buttons for background machines always read "off"
	uchar old_x,old_y;
	
public: 
				KempstonMouseInterface	( Machine* );
				~KempstonMouseInterface	( );

virtual bool	IsA			( int id ) const		{ return id==isa_KempstonMouseInterface || ZxItem::IsA(id); }
virtual	void	Input		( Time, long cc, ushort address, uchar& byte, uchar& mask );

	uchar		GetXAxis	( )			
	{
		if( GetMachine()==front_machine() ) old_x = Mouse::XPos();
		return old_x;
	}
	
	uchar		GetYAxis	( )			
	{
		if( GetMachine()==front_machine() ) old_y = Mouse::YPos();
		return old_y;
	}
	
	uchar		GetButtons	( )			
	{
		return GetMachine()==front_machine() 
			? 0xff - (Mouse::LeftButton()<<1) - Mouse::RightButton()	// 2-button version
			: 0xff; 
	}
};



#endif









