/*	Copyright  (c)	Günter Woigk 1995 - 2008
  					mailto:kio@little-bat.de

 	This program is distributed in the hope that it will be useful,
 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

 	Permission to use, copy, modify, distribute, and sell this software and
 	its documentation for any purpose is hereby granted without fee, provided
 	that the above copyright notice appear in all copies and that both that
 	copyright notice and this permission notice appear in supporting
 	documentation, and that the name of the copyright holder not be used
 	in advertising or publicity pertaining to distribution of the software
 	without specific, written prior permission.  The copyright holder makes no
 	representations about the suitability of this software for any purpose.
 	It is provided "as is" without express or implied warranty.

 	THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 	INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 	EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 	DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 	TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 	PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef Mmu128k_h
#define Mmu128k_h

#import "Mmu.h"



class Mmu128k : public Mmu
{
	void		page_rom_128k		();
	void		page_ram_128k		();
	void		page_mem_128k		();
protected:	
	void		page_mem_48k		();
	
public: 

				Mmu128k				( Machine* );
				Mmu128k				( Machine*, cstr name, cstr o_addr, cstr i_addr );				
//virtual		~Mmu128k			();

virtual bool	IsA					( int id ) const		{ return id==isa_Mmu128k || Mmu::IsA(id); }
virtual void	Reset				( Time, long cc );
virtual void	PowerOn				( Time, long cc );
virtual void	Output				( Time, long cc, ushort addr, uchar byte );
//virtual uchar	Input				( Time, long cc, ushort addr );

virtual bool	HasPort7ffd			()		const throw()	{ return yes; }

//	set ports:
//	override locked_to_48k
//	• setup during initialisation
//	• perform selections in control panels
//	do not update screen up to current cc!

virtual void	SetPort7ffd			( uchar n );
virtual void	SetLockedTo48k		( bool f )				{ SetPort7ffd( f ? port_7ffd|0x20 : port_7ffd&~0x20 ); }
virtual bool	IsLockedTo48k		()		const throw()	{ return port_7ffd&0x20; }
};




#endif









