/*	Copyright  (c)	Günter Woigk  2006
  					mailto:kio@little-bat.de

 	This program is distributed in the hope that it will be useful,
 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

 	Permission to use, copy, modify, distribute, and sell this software and
 	its documentation for any purpose is hereby granted without fee, provided
 	that the above copyright notice appear in all copies and that both that
 	copyright notice and this permission notice appear in supporting
 	documentation, and that the name of the copyright holder not be used
 	in advertising or publicity pertaining to distribution of the software
 	without specific, written prior permission.  The copyright holder makes no
 	representations about the suitability of this software for any purpose.
 	It is provided "as is" without express or implied warranty.

 	THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 	INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 	EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 	DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 	TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 	PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef SinclairZxInterface2_h
#define SinclairZxInterface2_h


#import	"Joystick.h"
#import	"ZxItem.h"


class SinclairZxInterface2 : public ZxItem
{
				JoystickID		joystick1;
				JoystickID		joystick2;
				ushort*			rom;
				cstr			filepath;

public:
				SinclairZxInterface2	( Machine* );
				~SinclairZxInterface2	( );

	void		SetJoystick1		( JoystickID j )	{ joystick1=j; };
	void		SetJoystick2		( JoystickID j )	{ joystick2=j; };
	JoystickID	GetJoystick1		( )				{ return joystick1; }
	JoystickID	GetJoystick2		( )				{ return joystick2; }

	void		LoadRom				( cstr file_path );
	void		UnloadRom			( ); 
	cstr		LoadedRom			( )				{ return filepath; }

virtual bool	IsA					( int id ) const	{ return id==isa_SinclairZxInterface2 || ZxItem::IsA(id); }
//	void		PowerOn				( Time, long cc );
//	void		Reset				( Time, long cc );
//	void		Output				( Time, long cc, ushort address, uchar byte );
	void		Input				( Time, long cc, ushort address, uchar& byte, uchar& mask );
//	void		DspBufferEnd		( Time, long cc );
};



#endif

