/*	Copyright  (c)	Günter Woigk 2004 - 2007
  					mailto:kio@little-bat.de

 	This program is distributed in the hope that it will be useful,
 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

 	Permission to use, copy, modify, distribute, and sell this software and
 	its documentation for any purpose is hereby granted without fee, provided
 	that the above copyright notice appear in all copies and that both that
 	copyright notice and this permission notice appear in supporting
 	documentation, and that the name of the copyright holder not be used
 	in advertising or publicity pertaining to distribution of the software
 	without specific, written prior permission.  The copyright holder makes no
 	representations about the suitability of this software for any purpose.
 	It is provided "as is" without express or implied warranty.

 	THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 	INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 	EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 	DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 	TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 	PERFORMANCE OF THIS SOFTWARE.
*/


#import "NXPanel.h"


@interface UlaPanel : NXPanel
{
    IBOutlet id view_ula_clock;
    IBOutlet id view_ula_clock_percent;

    IBOutlet id view_cpu_clock;
    IBOutlet id view_cpu_clock_divider;

    IBOutlet id view_lines_before_screen;
    IBOutlet id view_lines_in_screen;
    IBOutlet id view_lines_after_screen;
    IBOutlet id view_screen_pixels_per_line;
	IBOutlet id checkbox_show_inner_screen;
    IBOutlet id view_bytes_per_line;
    IBOutlet id view_cpu_clocks_per_line;
    IBOutlet id view_frames_per_second;
    IBOutlet id view_cpu_cycles_per_frame;
	
    IBOutlet id view_crt_current_row;
    IBOutlet id view_crt_current_col;
    IBOutlet id view_crt_is_in_screen;	

    IBOutlet id checkbox_use_waitmap;
    IBOutlet id view_waitmap_offset;
    IBOutlet id view_waitmap;

    IBOutlet id view_border;
    IBOutlet id view_ear;
    IBOutlet id view_mic;
    IBOutlet id view_frames_hit;	
	
// --------------------------------
//	Port 7ffd and 1ffd views:

    IBOutlet id separator_7ffd;
    IBOutlet id view_7ffd;
    IBOutlet id view_page_c000;
    IBOutlet id view_page_8000;
    IBOutlet id view_page_4000;
    IBOutlet id view_page_0000;
    IBOutlet id view_videopage;
    IBOutlet id checkbox_locked_to_48k;

// Port 1ffd-only views:

    IBOutlet id view_1ffd;
    IBOutlet id textfield_1ffd;
    IBOutlet id checkbox_ram_only_mode;
    IBOutlet id textfield_rom_0000;
    IBOutlet id textfield_disc_motor;
    IBOutlet id view_disc_motor;
    IBOutlet id textfield_printer_strobe;
    IBOutlet id view_printer_strobe;
}

// Port 7ffd actions:
-(IBAction)setPort7ffd:(id)sender;
-(IBAction)setPageC000:(id)sender;
-(IBAction)setPage8000:(id)sender;
-(IBAction)setPage4000:(id)sender;
-(IBAction)setPage0000:(id)sender;
-(IBAction)setVideoram:(id)sender;
-(IBAction)setLockedTo48k:(id)sender;

// Port 1ffd actions:
-(IBAction)setPort1ffd:(id)sender;
-(IBAction)setRamOnlyMode:(id)sender;
-(IBAction)setDiscMotor:(id)sender;
-(IBAction)setPrinterStrobe:(id)sender;

-(IBAction)setUlaClock:(id)sender;
-(IBAction)setUlaClockPercent:(id)sender;
-(IBAction)setCpuClock:(id)sender;
-(IBAction)setCpuClockDivider:(id)sender;

-(IBAction)setFramesPerSecond:(id)sender;
-(IBAction)setCpuClocksPerLine:(id)sender;
-(IBAction)setCpuCyclesPerFrame:(id)sender;
-(IBAction)setBytesPerLine:(id)sender;
-(IBAction)setShowInnerScreen:(id)sender;
-(IBAction)setTopBorderLines:(id)sender;
-(IBAction)setBottomBorderLines:(id)sender;
-(IBAction)setUseWaitmap:(id)sender;
-(IBAction)setWaitmapOffset:(id)sender;
-(IBAction)setWaitmap:(id)sender;
-(IBAction)setBorder:(id)sender;
-(IBAction)doRestoreDefaults:(id)sender;

@end








