

#import "Item.h"
#import "Machine.h"
#import "Ula.h"
#import "Cpu options.h"

 erewbtr
 br
 z
 ntzn
 ztm
 tzm
 tum
 
 
 
 
 
// ----	memory pages ----

#define			CPU_PAGESIZE			(1<<CPU_PAGEBITS)
#define			CPU_PAGEMASK			(CPU_PAGESIZE-1)
#define			CPU_PAGES				(0x10000>>CPU_PAGEBITS)

#if defined(_BIG_ENDIAN)	// m68k, ppc
	struct twobytes { uchar hi,lo; };
#else
	struct twobytes { uchar lo,hi; };
#endif	

struct PgInfo
{
    ushort*		core_r;				// flags in the high byte, data in the low byte
    ushort*		core_w;				// flags in the high byte, data in the low byte
	uchar*		waitmap_r; 
	long		waitmap_r_size;	
	uchar*		waitmap_w; 
	long		waitmap_w_size;	
  #ifdef CPU_STATISTICS
	ulong*		count_r;
	ulong*		count_w;
	ulong*		count_x;
  #endif

	ushort&		both_r				( ushort const addr )		{ return core_r[addr]; }
	ushort&		both_w				( ushort const addr )		{ return core_w[addr]; }
	uchar&		data_r				( ushort const addr )		{ return ((twobytes*)(core_r+addr))->lo; }
	uchar&		data_w				( ushort const addr )		{ return ((twobytes*)(core_w+addr))->lo; }
	uchar&		flags_r				( ushort const addr )		{ return ((twobytes*)(core_r+addr))->hi; }
	uchar&		flags_w				( ushort const addr )		{ return ((twobytes*)(core_w+addr))->hi; }
};



// ----	cpu base class ----

class Cpu : public Item
{
protected:
	PgInfo		page[CPU_PAGES];	// attached memory 

	Ula*		crtc;
//	long		crt_cycle;			// crt execution counter (based on cpu T cycle counter)
	long		cpu_cycle;			// cpu T cycle counter

public:
				Cpu					( Machine* m, cstr s );
virtual void	PowerOn				( Time t, long cc );
virtual	void	Reset				( Time t, long cc );
virtual	bool	Run					( long end_cc, int options ) = 0;

// access T cycles counter:
    long&		CpuCycle			( )					{ return cpu_cycle; }
//	long&		CrtCycle			( )					{ return crt_cycle; }

// attach memory:
    void		MapRam				( ushort addr, ushort size, ushort* data, uptr waitmap=0, long wm_size=0 );
    void		MapRom				( ushort addr, ushort size, ushort* data, uptr waitmap=0, long wm_size=0 );
    void		MapWom				( ushort addr, ushort size, ushort* data, uptr waitmap=0, long wm_size=0 );

// access memory:
	PgInfo&		Page				( ushort const addr )					{ return page[addr>>CPU_PAGEBITS]; }

    ushort*		RdPtr				( ushort const addr )					{ return Page(addr).core_r + addr; }
    ushort*		WrPtr				( ushort const addr )					{ return Page(addr).core_w + addr; }

	uchar		Peek				( ushort const addr )					{ return Page(addr).both_r(addr); }
	void		Poke				( ushort const addr, uchar const c )	{		 Page(addr).data_w(addr) = c; }
   
// debugger:
	ushort		stack_breakpoint;
	
// profiling:
  #ifdef CPU_STATISTICS
	void		MapXCounts			( ushort addr, ushort sz, ulong* map );
	void		MapRCounts			( ushort addr, ushort sz, ulong* map );
	void		MapWCounts			( ushort addr, ushort sz, ulong* map );
	void		MapCounts			( ushort addr, ushort sz, ulong* rmap, ulong* wmap, ulong* xmap );

    ulong&		cnt_x				( ushort const addr )					{ return Page(addr).xcount[addr];	  }
    ulong&		cnt_r				( ushort const addr )					{ return Page(addr).rcount[addr];	  }
    ulong&		cnt_w				( ushort const addr )					{ return Page(addr).wcount[addr];	  }
	
	long		cnt_op[256];
	long		cnt_cb[256];
	long		cnt_ed[256];
	long		cnt_xy[256];
	long		cnt_xycb[256];
  #endif
};











