

#define SAFE	3
#define	LOG		1

#import	"Cpu.h"
#import	"Machine.h"

ksdj larh lskjf bsöbnsrtnbr nrtnrn
r


static ushort	noreadpage[CPU_PAGESIZE];		// dummy page for unmapped memory
static ushort	nowritepage[CPU_PAGESIZE];		// dito
#if CPU_STATISTICS
static ulong	nocountmap[CPU_PAGESIZE];		// dummy count map
#endif


Cpu::Cpu( Machine* m, cstr s ) 
:	Item(m,s)	
{ 
	m->cpu = this;

//	crt_cycle = 0; 
	cpu_cycle = 0;
	crtc	  = NULL; 

#if CPU_STATISTICS
	memset( cnt_instr,0,sizeof(cnt_instr) );
	memset( cnt_cb,0,   sizeof(cnt_cb) );
	memset( cnt_ed,0,   sizeof(cnt_ed) );
	memset( cnt_xy,0,   sizeof(cnt_xy) );
	memset( cnt_xycb,0, sizeof(cnt_xycb) );
	MapCounts( addr, 0x10000, NULL,NULL,NULL );
#endif

// init global dummy read page for non-mapped ram: 
// note: no need to init nowritepage[]: 0x0000 is ok 
	TRAP(sizeof(twobytes)!=2);
	for( int i=0; i<CPU_PAGESIZE; i++ ) noreadpage[i] = 0x00FF;		// flags=0x00, data=0xFF

// setup memory to no_memory && no_breakpoints && no_waitmap
	for( int i=0; i<CPU_PAGES; i++ )
	{
		PgInfo& p = page[i];
		p.core_w		 = nowritepage - i*CPU_PAGESIZE;
		p.core_r		 = noreadpage  - i*CPU_PAGESIZE;
		p.waitmap_w		 = p.waitmap_r 	    = NULL; 
		p.waitmap_w_size = p.waitmap_r_size = 0; 
	}
}


void Cpu::PowerOn ( Time t, long cc )		
{ 
//	crt_cycle = cc; 
	cpu_cycle = cc; 
	crtc	  = machine->ula;	
	
	XXTRAP(!crtc); 
}


void Cpu::Reset ( Time t, long cc )
{
	cpu_cycle = cc;
}


/* ----	attach ram/rom to address space --------------
		Attach real memory to cpu address space
		
		For best performance set CPU_PAGESIZE to the page size of the emulated machine.
		If you emulate multiple machines, set it to the lowest page size of any machine.
	
		addr	= cpu start address of page
		size	= size of page 
					0x0000 is assumed to mean 0x10000 (entire address range)
					addr and size must be multiples of CPU_PAGESIZE
					addr+size must not extend beyond address space end 0x10000 

		page	= pointer to page data

		waitmap	= wait cycles map for this page				
		wmsize	= size of waitmap
					NULL  => no waitstates map
					access to waitmap: cc += waitmap[cc%wmsize]
		
		data and flags pointers in PgInfo struct point to the virtual location of address $0000
		so that you can access data using page.data_r[addr>>CPU_PAGEBITS][addr]
*/
void Cpu::MapRam ( ushort addr, ushort size, ushort* core, uptr waitmap, long wm_size )
{
	size -= CPU_PAGESIZE;			// note: size=0  =>  size=0x10000

	XXXTRAP(!this);
	XXTRAP(!core);
	XXTRAP(addr&CPU_PAGEMASK);		// addr muss in's 'CPU_PAGESIZE' raster passen
	XXTRAP(size&CPU_PAGEMASK);		// addr+size ebenfass wieder
	XXTRAP(size>0xffff-addr);		// wrap around address space end
	XXTRAP(!waitmap&&core[0]&cpu_waitmap);
	XXTRAP( core < machine->core );
	XXTRAP( core+size+CPU_PAGESIZE > machine->ram+machine->model->ram_size);

	PgInfo* a = page + (addr>>CPU_PAGEBITS);
	PgInfo* e = a    + (size>>CPU_PAGEBITS);
	
	core -= addr;
	
	for( ;a<=e; a++ ) 
	{
		a->core_w		  = a->core_r		  = core;
		a->waitmap_w	  = a->waitmap_r	  = waitmap; 
		a->waitmap_w_size = a->waitmap_r_size = wm_size; 
	}
}

void Cpu::MapWom ( ushort addr, ushort size, ushort* core, uptr waitmap, long wm_size )
{
	size -= CPU_PAGESIZE;			// note: size=0  =>  size=0x10000

	XXXTRAP(!this);
	XXTRAP(!core);
	XXTRAP(addr&CPU_PAGEMASK);		// addr muss in's 'CPU_PAGESIZE' raster passen
	XXTRAP(size&CPU_PAGEMASK);		// addr+size ebenfass wieder
	XXTRAP(size>0xffff-addr);		// wrap around address space end
	XXTRAP(!waitmap&&core[0]&cpu_waitmap);
	XXTRAP( core < machine->core );
	XXTRAP( core+size+CPU_PAGESIZE > machine->ram+machine->model->ram_size);

	PgInfo* a = page + (addr>>CPU_PAGEBITS);
	PgInfo* e = a    + (size>>CPU_PAGEBITS);
	
	core -= addr;
	
	for( ;a<=e; a++ ) 
	{
		a->core_w		  = core;
		a->waitmap_w	  = waitmap; 
		a->waitmap_w_size = wm_size; 
	}
}

void Cpu::MapRom ( ushort addr, ushort size, ushort* core, uptr waitmap, long wm_size )
{
	size -= CPU_PAGESIZE;			// note: size=0  =>  size=0x10000

	XXXTRAP(!this);
	XXTRAP(!core);
	XXTRAP(addr&CPU_PAGEMASK);		// addr muss in's 'CPU_PAGESIZE' raster passen
	XXTRAP(size&CPU_PAGEMASK);		// addr+size ebenfass wieder
	XXTRAP(size>0xffff-addr);		// wrap around address space end
	XXTRAP(!waitmap&&core[0]&cpu_waitmap);
	XXTRAP( core < machine->core );
	XXTRAP( core+size+CPU_PAGESIZE > machine->ram+machine->model->ram_size);

	PgInfo* a = page + (addr>>CPU_PAGEBITS);
	PgInfo* e = a    + (size>>CPU_PAGEBITS);
	
	core -= addr;
	
	for( ;a<=e; a++ ) 
	{
		a->core_r		  = core;
		a->waitmap_r	  = waitmap; 
		a->waitmap_r_size = wm_size; 
	}
}






#ifdef CPU_STATISTICS
/* ----	Map memory access count pages -------------------
		The following count arrays count memory access for each byte
		M1Counts counts opcode reading (program execution)
		RdCounts counts read access 
		WrCounts counts write access 
*/
void Cpu::MapM1Counts ( ushort addr, ushort size, ulong* map )
{
	XXTRAP(addr&CPU_PAGEMASK);		// addr muss in's 'CPU_PAGESIZE' raster passen
	XXTRAP(size&CPU_PAGEMASK);		// addr+size ebenfass wieder

	pInfo* a = this->page  +  (addr>>CPU_PAGEBITS);
	pInfo* p = a           +  (size>>CPU_PAGEBITS);
	
	if( size==0 ) { p += CPU_PAGES; }				// 0 == 0x10000
	XXTRAP( p > this->page+CPU_PAGES );				// wrap around address space end

	if(map) { map  -= addr; while(--p>=a) p->mcount = map; }
	else	{ addr += size; while(--p>=a) { addr -= CPU_PAGESIZE; p->mcount = nocountmap-addr; } }
}

void Cpu::MapRdCounts ( ushort addr, ushort sz, ulong* map )
{
	XXTRAP(addr&CPU_PAGEMASK);		// addr muss in's 'CPU_PAGESIZE' raster passen
	XXTRAP(size&CPU_PAGEMASK);		// addr+size ebenfass wieder

	pInfo* a = this->page  +  (addr>>CPU_PAGEBITS);
	pInfo* p = a           +  (size>>CPU_PAGEBITS);
	
	if( size==0 ) { p += CPU_PAGES; }				// 0 == 0x10000
	XXTRAP( p > this->page+CPU_PAGES );				// wrap around address space end

	if(map) { map  -= addr; while(--p>=a) p->rcount = map; }
	else	{ addr += size; while(--p>=a) { addr -= CPU_PAGESIZE; p->rcount = nocountmap-addr; } }
}

void Cpu::MapWrCounts ( ushort addr, ushort sz, ulong* map )
{
	XXTRAP(addr&CPU_PAGEMASK);		// addr muss in's 'CPU_PAGESIZE' raster passen
	XXTRAP(size&CPU_PAGEMASK);		// addr+size ebenfass wieder

	pInfo* a = this->page  +  (addr>>CPU_PAGEBITS);
	pInfo* p = a           +  (size>>CPU_PAGEBITS);
	
	if( size==0 ) { p += CPU_PAGES; }				// 0 == 0x10000
	XXTRAP( p > this->page+CPU_PAGES );				// wrap around address space end

	if(map) { map  -= addr; while(--p>=a) p->wcount = map; }
	else	{ addr += size; while(--p>=a) { addr -= CPU_PAGESIZE; p->wcount = nocountmap-addr; } }
}

void Cpu::MapCounts ( ushort addr, ushort sz, ulong* rmap, ulong* wmap, ulong* m1map )
{
	XXTRAP(addr&CPU_PAGEMASK);		// addr muss in's 'CPU_PAGESIZE' raster passen
	XXTRAP(size&CPU_PAGEMASK);		// addr+size ebenfass wieder

	pInfo* a = this->page  +  (addr>>CPU_PAGEBITS);
	pInfo* p = a           +  (size>>CPU_PAGEBITS);
	
	if( size==0 ) { p += CPU_PAGES; }				// 0 == 0x10000
	XXTRAP( p > this->page+CPU_PAGES );				// wrap around address space end

	if(rmap)  rmap -= addr; 
	if(wmap)  wmap -= addr; 
	if(m1map) m1map -= addr; 
	ulong* nomap = nocountmap + addr + size;
	
	while(--p>=a) 
	{ 
		nomap -= CPU_PAGESIZE; 
		p->mcount = m1map?m1map:nomap; 
		p->rcount = rmap?rmap:nomap; 
		p->wcount = wmap?wmap:nomap; 
	}
}
#endif











