


/* #####################################################################

				options and callback functions for zxsp

   ##################################################################### */

#undef	CPU_STATISTICS			1
#define	CPU_PAGEBITS			13

enum 
{	cpu_fastest		= 0,		// no gimmicks
	cpu_waitmap		= 1<<8,		// add wait cycles from pg.[rw]waitmap
	cpu_break_x		= 1<<9,		// option and bit position of 'break on execute' bit in pg.[rw]_flags[]
	cpu_break_w		= 1<<10,	// option and bit position of 'break on write'	 bit in pg.[rw]_flags[]
	cpu_break_r		= 1<<11,	// option and bit position of 'break on read'	 bit in pg.[rw]_flags[]
	cpu_patch		= 1<<12,	// option and bit position of 'patch'			 bit in pg.[rw]_flags[]
	cpu_crtc		= 1<<13,	// update screen before writing to ram
	cpu_break_sp	= 1<<14,	// check stack_watchpoint in RET and POP

	cpu_count_x		= 1<<15,	// #ifdef CPU_STATISTICS: create program execution profile
	cpu_count_r		= 1<<16, 	// #ifdef CPU_STATISTICS: create memory read access profile
	cpu_count_w		= 1<<17, 	// #ifdef CPU_STATISTICS: create memory write access profile
	cpu_count_op	= 1<<18,	// #ifdef CPU_STATISTICS: create instruction profiles

	cpu_break_rwx	= cpu_break_r|cpu_break_w|cpu_break_x		// for convenience
};



#define	CPU_INFO_INIT			long cc_crt = crtc->GetCpuCycleOfNextCrtRead();	/* = crt_cycle; */
#define	CPU_INFO_EXIT			/* crt_cycle = cc_crt; */

#define	CPU_INFO_NMI			r+=1; GetMachine()->NmiAcknowledgedAtCycle(cc,pc);;
#define	CPU_INFO_IRPT			r+=1; c = GetMachine()->InterruptAcknowledgedAtCycle(cc,pc);;
#define	CPU_INFO_RETI(PC)		GetMachine()->InstructionRetiAtCycle(cc,PC)
#define	CPU_INFO_RETN(PC)		GetMachine()->InstructionRetnAtCycle(cc,PC)
#define	CPU_INFO_ILLEGAL(PC)	if(GetMachine()->IllegalInstructionAtCycle(cc,PC))	{ ccx=-1; };;

#define	CPU_INFO_EX_HL_xSP		CPU_INFO_POP 
#define	CPU_INFO_RET			CPU_INFO_POP
#define	CPU_INFO_POP			if( options&cpu_break_sp && SP==stack_breakpoint )									\
								{ GetMachine()->HaltCpu(); GetMachine()->cpu_options &= ~cpu_break_sp; ccx=-1; };;


#define CPU_INFO_HALT			if( options&cpu_waitmap ) LOOP;	wm = (ccx-cc+3)/4; cc+=wm*4; r+=wm; 



#define OUTPUT(A,R)		{ cc+=3; cpu_cycle = cc; GetMachine()->OutputAtCycle(cc,A,R);  cc = cpu_cycle+1; }
#define INPUT(A,R)		{ cc+=3; cpu_cycle = cc; R = GetMachine()->InputAtCycle(cc,A); cc = cpu_cycle+1; }

#define	CC_WAIT_R(CC)	cc += pg.waitmap_r[(CC)%pg.waitmap_r_size]
#define	CC_WAIT_W(CC)	cc += pg.waitmap_w[(CC)%pg.waitmap_w_size]

#define	PEEK(R,A)		{	PgInfo& pg = Page(A);			\
							wm = pg.both_r(A);				\
							R = uchar(wm);					\
							if( (wm&=ushort(options)) )		\
							{								\
								if(wm&cpu_break_r) { GetMachine()->HaltCpu(); GetMachine()->break_ptr=&pg.both_r(A); ccx=-1; }	\
								if(wm&cpu_waitmap) { CC_WAIT_R(cc+2); }			\
							};	cc+=3;						\
						}

#define	POKE(A,R)		{	PgInfo& pg = Page(A);			\
							wm = pg.both_w(A);				\
							if( (wm&=ushort(options)) )		\
							{								\
								if(wm&cpu_break_w) { GetMachine()->HaltCpu(); GetMachine()->break_ptr=&pg.both_w(A); ccx=-1; }	\
								if(wm&cpu_waitmap) { CC_WAIT_W(cc+2); }						\
								if(wm&cpu_crtc)	   { if( (cc+2)>=cc_crt ) cc_crt = crtc->UpdateScreenUpToCycle(cc+2); }		\
							};	cc+=3;						\
							pg.data_w(A) = R;				\
						}

#define	GET_INSTR(R)										\
		{	PgInfo& pg = Page(pc);							\
			wm = pg.both_r(pc);								\
			R = uchar(wm);									\
			if( (wm&=ushort(options)) )						\
			{												\
				if(wm&cpu_patch)   { SAVE_REGISTERS; R = GetMachine()->PatchAtCycle(cc+2,pc,R);						\
									 LOAD_REGISTERS; if(GetMachine()->cpu_state&7/*halted?*/) EXIT; }				\
				if(wm&cpu_break_x) { if(GetMachine()->break_ptr==&pg.both_r(pc)) { GetMachine()->break_ptr=0; } else		\
								   { GetMachine()->HaltCpu(); GetMachine()->break_ptr=&pg.both_r(pc); EXIT; } }			\
				if(wm&cpu_waitmap) { CC_WAIT_R(cc+2); }		\
			};	cc+=4; pc+=1; r+=1;							\
		}

#define	GET_BYTE(RGL)	{	PgInfo& pg = Page(pc);			\
							wm = pg.both_r(pc);				\
							RGL uchar(wm);					\
							if( (wm&=ushort(options)) )		\
							{								\
								if(wm&cpu_break_x) { GetMachine()->HaltCpu(); GetMachine()->break_ptr=&pg.both_r(pc); ccx=-1; }\
								if(wm&cpu_waitmap) { CC_WAIT_R(cc+2); }						\
							};	pc+=1;						\
						}
												
#define	GET_N(R)		{ GET_BYTE(R=);		  cc+=3; }						
#define	SKIP_N()		{ GET_BYTE((void));	  cc+=3; }
#define	GET_XYCB_OP(R)	{ GET_BYTE(R=);		  cc+=3; SKIP_2X1CC(pc-1); }
#define	GET_ED_OP(R)	{ GET_BYTE(R=); r+=1; cc+=4; }
#define	GET_XY_OP(R)	{ GET_BYTE(R=); r+=1; cc+=4; }
#define	GET_CB_OP(R)	{ GET_BYTE(R=); r+=1; cc+=4; }


/*	1 cc with wait test 
*/
#define	SKIP_1CC(A)	{	cc += 1;									\
							PgInfo& pg = Page(A);					\
							wm = pg.both_r(A);						\
							if( wm&ushort(options)&cpu_waitmap )	\
							{										\
								CC_WAIT_R(cc+1);	\
							}						\
						}


/*	2 cc with wait test 
*/
#define	SKIP_2X1CC(A)	{	cc += 2;								\
							PgInfo& pg = Page(A);					\
							wm = pg.both_r(A);						\
							if( wm&ushort(options)&cpu_waitmap )	\
							{										\
								CC_WAIT_R(cc+0);	\
								CC_WAIT_R(cc+1);	\
							}						\
						}


/*	4 cc with wait test in all cycles
	--> nur in RLD/RRD
*/
#define	SKIP_4X1CC(A)	{	cc += 4;								\
							PgInfo& pg = Page(A);					\
							wm = pg.both_r(A);						\
							if( wm&ushort(options)&cpu_waitmap )	\
							{										\
								CC_WAIT_R(cc-2);	\
							 	CC_WAIT_R(cc-1); 	\
								CC_WAIT_R(cc-0);	\
							 	CC_WAIT_R(cc+1); 	\
							}						\
						}


/*	5 cc with wait test in all cycles
*/
#define	SKIP_5X1CC(A)	{	cc += 5;								\
							PgInfo& pg = Page(A);					\
							wm = pg.both_r(A);						\
							if( wm&ushort(options)&cpu_waitmap )	\
							{										\
								CC_WAIT_R(cc-3);	\
								CC_WAIT_R(cc-2);	\
								CC_WAIT_R(cc-1);	\
								CC_WAIT_R(cc+0);	\
								CC_WAIT_R(cc+1);	\
							}						\
						}


/*	7 cc with wait test in all cycles
*/
#define	SKIP_7X1CC(A)	{	cc += 7;								\
							PgInfo& pg = Page(A);					\
							wm = pg.both_r(A);						\
							if( wm&ushort(options)&cpu_waitmap )	\
							{										\
								CC_WAIT_R(cc-5);	\
								CC_WAIT_R(cc-4);	\
								CC_WAIT_R(cc-3);	\
								CC_WAIT_R(cc-2);	\
								CC_WAIT_R(cc-1);	\
								CC_WAIT_R(cc-0);	\
								CC_WAIT_R(cc+1);	\
							}						\
						}


						







































