// utf-8

/*	Copyright  (c)	Günter Woigk   1995-2006
  					mailto:kio@little-bat.de

	This file is free software

 	This program is distributed in the hope that it will be useful,
 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

 	Permission to use, copy, modify, distribute, and sell this software and
 	its documentation for any purpose is hereby granted without fee, provided
 	that the above copyright notice appear in all copies and that both that
 	copyright notice and this permission notice appear in supporting
 	documentation, and that the name of the copyright holder not be used
 	in advertising or publicity pertaining to distribution of the software
 	without specific, written prior permission. The copyright holder makes no
 	representations about the suitability of this software for any purpose.
 	It is provided "as is" without express or implied warranty.

 	THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 	INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 	EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 	DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 	TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 	PERFORMANCE OF THIS SOFTWARE.

	1995-06-29 kio	started work on pascal string lib
	2000-01-28 kio	started work on c string lib
	2004-12-16 kio	split into functions and qstring part for multi threading safe version for Cocoa
	2006-10-31 kio	renamed QString() to QuickStr() wg. naming collission with Qt.
	2008-05-14 kio	renamed QuickStr() to TempStr()
*/

#define	SAFE	1
#define	LOG		1

#include	"config.h"
#include	<math.h>

#ifdef HAVE_NAN_H
#include	<nan.h>
#endif

#include	"cstrings.h"


#ifndef NAN
const double NAN = 0.0/0.0;
#endif


/* ----------------------------------------------------------
		POOL HANDLING

		as a quick multi-threading safe solution
		all strings are put into NSMutableData with
		auto-deallocation
---------------------------------------------------------- */




/* ----	allocate and return a string from the pool ---------------------------------
		the string's last byte is preset with 0
*/
str TempStr ( int len ) throw(bad_alloc)
{
	str s = (ptr)[[NSMutableData dataWithCapacity:len+1] mutableBytes];
	s[len] = 0;
	return s;
}




/* ----	Include the function implementations ------------------------
*/

#define	 QSMAXLEN 256
#include "cstrings_functions.h"





