// utf-8

/**	Copyright:	1995 Günter Woigk
  				mailto:kio@little-bat.de

 	This program is distributed in the hope that it will be useful,
 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

 	Permission to use, copy, modify, distribute, and sell this software and
 	its documentation for any purpose is hereby granted without fee, provided
 	that the above copyright notice appear in all copies and that both that
 	copyright notice and this permission notice appear in supporting
 	documentation, and that the name of the copyright holder not be used
 	in advertising or publicity pertaining to distribution of the software
 	without specific, written prior permission.  The copyright holder makes no
 	representations about the suitability of this software for any purpose.
 	It is provided "as is" without express or implied warranty.

 	THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 	INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 	EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 	DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 	TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 	PERFORMANCE OF THIS SOFTWARE.
*/

#ifndef _memmove_h_
#define _memmove_h_


// move memory to lower address
// source and destination pointers q and z point to
// the start address of their respective memory block

inline void memmove ( const void* q, void* z, long n )
{
	void* e = (char*)q + n;
	if (n&1)	*((char* )z)++ = *((char *)q)++;
	if (n&2)	*((short*)z)++ = *((short*)q)++;
	if (n&4)	*((long* )z)++ = *((long *)q)++;
	while (q<e)
	{	((long*)z)[0] = ((long*)q)[0];
		((long*)z)[1] = ((long*)q)[1];
		(long*)q+=2;
		(long*)z+=2;
	}
}


// move memory to higher address
// source and destination pointers q and z point 
// behind their respective memory block

inline void memmove_r ( const void* q, void* z, long n )
{
	void* e = (char*)q - n;
	if (n&1)	*--((char *)z) = *--((char *)q);
	if (n&2)	*--((short*)z) = *--((short*)q);
	if (n&4)	*--((long *)z) = *--((long *)q);
	while (q>e)
	{	(long*)q -= 2;
		(long*)z -= 2;
		((long*)z)[1] = ((long*)q)[1];
		((long*)z)[0] = ((long*)q)[0];
	}
}


#endif

