/*	Copyright  (c)	Günter Woigk 1999 - 2007
  					mailto:kio@little-bat.de

	This file is free software

 	This program is distributed in the hope that it will be useful,
 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

 	Permission to use, copy, modify, distribute, and sell this software and
 	its documentation for any purpose is hereby granted without fee, provided
 	that the above copyright notice appear in all copies and that both that
 	copyright notice and this permission notice appear in supporting
 	documentation, and that the name of the copyright holder not be used
 	in advertising or publicity pertaining to distribution of the software
 	without specific, written prior permission. The copyright holder makes no
 	representations about the suitability of this software for any purpose.
 	It is provided "as is" without express or implied warranty.

 	THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 	INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 	EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 	DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 	TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 	PERFORMANCE OF THIS SOFTWARE.

 	error handling

note:
	include errors.cp:  support for cstrings only, does not require class String
	_or_    serrors.cp: support for cstrings and class String strings


	01.jan.1999	kio	first work on this file
	16.sep.1999 kio	added string version
	17.feb.2001 kio	added possibility to #include custom error file
	09.nov.2001	kio	added support for class String, renamed ErrorText() to ErrorStr() / ErrorString()
*/

#define	SAFE	1
#define	LOG		0

#include	"config.h"
//#include	<string.h>
#include	<unistd.h>
#include 	"kio.h"
#include	"cstrings/cstrings.h"
#include	"errors.h"


cstr ETEXT[] = {
#define		EMAC(a,b)	b
#include	"error_emacs.h"
};


bool customError = 0;
char customErrorMsg[1024];
const nothrow_t nothrow={};




/* ----	get default error text for error ------------------------------------------------
		2008-05-14: does not call any memory allocating function
*/
cstr ErrorStr ( int/*OSErr*/ err )
{
	if (err==0)  return "no error";
	if (err==-1) return "unknown error (-1)";
	if (err>=EBAS && err<EBAS+(int)NELEM(ETEXT)) return ETEXT[err-EBAS];
	return strerror(err);
}


/* ----	get error text for current error ------------------------------------------------
*/
cstr ErrorStr ( )
{
	XTRAP(NoError()&&customError);		// note: clear error with ClearError() !!!

	if (customError) return DupStr(customErrorMsg);
	else             return ErrorStr(Error());
}



/* ----	set error code & text ------------------------------------------------
*/
void ForceError ( int/*OSErr*/ err, cstr custom_msg )
{
	ForceError(err);
	customError = 1;
	ptr z = customErrorMsg;
	cptr q = custom_msg;
	uint i = 0;
	for ( ; i<NELEM(customErrorMsg); i++ ) { if ( (z[i] = q[i]) == 0 ) return; }
	customErrorMsg[NELEM(customErrorMsg)-1] = 0;
}


#if 0
static OSErr err[4];
static cstr  msg[4];
static uint  idx;

void PushError ( )
{
	XTRAP(idx==NELEM(err));
	err[idx] = Error();
	msg[idx] = customError ? NewCopy(customErrorMsg) : NULL;
	idx++;
	ClearError();
}


void PopError ( )
{
	XXTRAP(idx==0);
	idx--;
	if(msg[idx]) { ForceError(err[idx],msg[idx]); delete[] msg[idx]; }
	else if(err[idx]) ForceError(err[idx]); else ClearError();
}


void DropError ( )
{
	XXTRAP(idx==0);
	idx--;
	delete[] msg[idx];
}
#endif














