/*	Copyright  (c)	Günter Woigk 1999 - 2007
					mailto:kio@little-bat.de

	This file is free software

 	This program is distributed in the hope that it will be useful,
 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

	Redistribution and use in source and binary forms, with or without 
	modification, are permitted provided that the following conditions are met:

	• Redistributions of source code must retain the above copyright notice, 
	  this list of conditions and the following disclaimer.
	• Redistributions in binary form must reproduce the above copyright notice, 
	  this list of conditions and the following disclaimer in the documentation 
	  and/or other materials provided with the distribution.

	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
	AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
	THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
	PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
	CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
	EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
	OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
	ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

	log to stderr

	2002-03-02 kio	replaced old macos classic log file
*/


#ifdef kio_h


extern void 		LogNL 	( );
extern void 		Log 	( cstr formatstring, ... );
extern void 		LogLine	( cstr formatstring, ... );


// conditional logging
#define	XLOG		(LOG>=1)
#define	XXLOG		(LOG>=2)
#define	XXXLOG		(LOG>=3)
#define	XXXXLOG		(LOG>=4)


#define	XLogNL		if ( !XLOG )	{} else LogNL
#define	XXLogNL		if ( !XXLOG )	{} else LogNL
#define	XXXLogNL	if ( !XXXLOG )	{} else LogNL
#define	XXXXLogNL	if ( !XXXXLOG )	{} else LogNL

#define	XLog		if ( !XLOG )	{} else Log
#define	XXLog		if ( !XXLOG )	{} else Log
#define	XXXLog		if ( !XXXLOG )	{} else Log
#define	XXXXLog		if ( !XXXXLOG )	{} else Log

#define	XLogLine	if ( !XLOG )	{} else LogLine
#define	XXLogLine	if ( !XXLOG )	{} else LogLine
#define	XXXLogLine	if ( !XXXLOG )	{} else LogLine
#define	XXXXLogLine	if ( !XXXXLOG )	{} else LogLine


struct LogIndent
{
	LogIndent	( cstr format, ... );
	~LogIndent	( );
};

#define LogIn		LogIndent _z_log_ident

#if XLOG
#define XLogIn		LogIn
#else
#define XLogIn		XLog
#endif

#if XXLOG
#define XXLogIn		LogIn
#else
#define XXLogIn		XXLog
#endif

#if XXXLOG
#define XXXLogIn	LogIn
#else
#define XXXLogIn	XXXLog
#endif

#if XXXXLOG
#define XXXXLogIn	LogIn
#else
#define XXXXLogIn	XXXXLog
#endif


#endif








