/*	Copyright  (c)	Günter Woigk 1999 - 2007
  					mailto:kio@little-bat.de

	This file is free software

 	This program is distributed in the hope that it will be useful,
 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

	Redistribution and use in source and binary forms, with or without 
	modification, are permitted provided that the following conditions are met:

	• Redistributions of source code must retain the above copyright notice, 
	  this list of conditions and the following disclaimer.
	• Redistributions in binary form must reproduce the above copyright notice, 
	  this list of conditions and the following disclaimer in the documentation 
	  and/or other materials provided with the distribution.

	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
	AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
	THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
	PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
	CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
	EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
	OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
	ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


	error handling

note:
	include errors.cp:  support for cstrings only, does not require class String
	_or_    serrors.cp: support for cstrings and class String strings


	2003-12-06 kio	derived this file from errors.cp
*/

#define	SAFE	2
#define	LOG		1

#include	"config.h"
#include	<string.h>
#include	<unistd.h>
#include	"kio.h"
#include 	"ustring/sstring.h"
#include	"errors.h"


cstr ETEXT[] = {
#define		EMAC(a,b)	b
#include	"error_emacs.h"
};


bool 	customError = 0;
String 	customErrorMsg;
const nothrow_t nothrow={};




/* ----	get default error text for error ------------------------------------------------
*/
cstr ErrorStr ( int/*OSErr*/ err )
{
	if (err==0)  return "no error";

	if (err==-1) return "unknown error (-1)";

	if (err>=EBAS && err<EBAS+(int)NELEM(ETEXT)) return ETEXT[err-EBAS];

	return Using("%s (%i)",strerror(err),(int)err);
}


/* ----	get error text for current error ------------------------------------------------
*/
cstr ErrorStr ( )
{
	return customError ? CString(customErrorMsg) : ErrorStr(Error());
}

String ErrorString ( )
{
	return customError ? customErrorMsg : ErrorStr(Error());
}



/* ----	set error code & text ------------------------------------------------
*/
void ForceError ( int/*OSErr*/ err, cString& msg )
{
	Error()        = err;
	customError    = 1;
	customErrorMsg = msg;
}

void ForceError ( int/*OSErr*/ err, cstr msg )
{
	Error()        = err;
	customErrorMsg = msg;
	customError    = 1;
}

void AppendToError ( cString& msg )
{
	customErrorMsg = ErrorString() + msg;
	customError    = 1;
}

void PrependToError ( cString& msg )
{
	customErrorMsg = msg + ErrorString();
	customError    = 1;
}


#if 0
static int/*OSErr*/  err[4];
static String msg[4];
static uint   idx;

void PushError ( )
{
	XTRAP(idx==NELEM(err));
	err[idx] = Error();
	msg[idx] = customError ? customErrorMsg : emptyString;
	idx++;
	ClearError();
}


void PopError ( )
{
	XXTRAP(idx==0);
	idx--;
	if (msg[idx].Len()) ForceError(err[idx],msg[idx]);
	else if (err[idx])  ForceError(err[idx]); else ClearError();
}


void DropError ( )
{
	XXTRAP(idx==0);
	idx--;
}
#endif















