/*	Copyright  (c)	Günter Woigk 2001 - 2007
  					mailto:kio@little-bat.de

	This file is free software

 	This program is distributed in the hope that it will be useful,
 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

	Redistribution and use in source and binary forms, with or without 
	modification, are permitted provided that the following conditions are met:

	• Redistributions of source code must retain the above copyright notice, 
	  this list of conditions and the following disclaimer.
	• Redistributions in binary form must reproduce the above copyright notice, 
	  this list of conditions and the following disclaimer in the documentation 
	  and/or other materials provided with the distribution.

	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
	AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
	THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
	PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
	CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
	EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
	OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
	ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef os_utilities_h
#define	os_utilities_h


#include	<time.h>
#include	"kio/kio.h"


/* ----	convert OS date type to user readable string ------------------
*/
extern	time_t	DateVal		( cstr   date );
//extern	cstr	DateStr		( time_t secs );		--> cstrings
//extern	cstr	TimeStr		( time_t secs );		--> cstrings



/* ----	system info ----------------------
*/
extern	cstr	HostName	( );						// localhost :-(
extern	void	SysLoad		( double load[3] );			// ranges: 1, 5, and 15 minutes

extern	time_t	BootTime	( );
extern	time_t	CurrentTime	( );		// time_t = long
//extern	time_t	UpTime		( );
extern	double	FloatCurrentTime ( );


/* ----	environment info ------------------
*/
extern	cstr	GetUser		( );
extern	cstr	GetGroup	( );



extern	str		ExecCmd		( /* cmd = argv[0] */ str const argv[], str const envv[]=NULL );
extern	str		ExecCmd		( cstr cmd, ... /* argv[1] ... NULL */ );


#endif

